package legion.muyue.best2048;

import android.util.Log;
import java.util.ArrayList;
import java.util.Random;

public class Game {

    private int[][] gameBoard;
    private Random random;
    private int score = 0;

    public Game() {
        gameBoard = new int[4][4];
        random = new Random();
        // Le score est initialisé à 0 par défaut
    }

    public void printArray() {
        for (int[] row : gameBoard) {
            String rowString = String.format("%6d%6d%6d%6d%n", row[0], row[1], row[2], row[3]);
            Log.d("Game", rowString);
        }
        Log.d("Game", "\n");
    }

    public void addNewNumbers() {
        ArrayList<int[]> emptySpaces = new ArrayList<>();

        for (int x = 0; x < 4; x++) {
            for (int y = 0; y < 4; y++) {
                if (gameBoard[x][y] == 0) {
                    emptySpaces.add(new int[]{x, y});
                }
            }
        }

        if (!emptySpaces.isEmpty()) {
            int choice = random.nextInt(emptySpaces.size());
            int[] coordinates = emptySpaces.get(choice);
            int x = coordinates[0];
            int y = coordinates[1];
            int newNumber;
            int randomNumber = random.nextInt(100);
            if (randomNumber < 85) {
                newNumber = 2;
            } else if (randomNumber < 95) {
                newNumber = 4;
            } else {
                newNumber = 8;
            }
            gameBoard[x][y] = newNumber;
        }
    }

    public void pushUp() {
        // Itération sur chaque colonne
        for (int y = 0; y < 4; y++) {
            // Itération sur chaque ligne de la colonne en commençant par la deuxième ligne (index 1)
            for (int x = 1; x < 4; x++) {
                // Si la case actuelle n'est pas vide
                if (gameBoard[x][y] != 0) {
                    int value = gameBoard[x][y]; // Stocke la valeur de la case actuelle
                    int currentX = x; // Variable pour suivre la position courante lors du déplacement vers le haut

                    // Déplacement vers le haut tant que la case précédente est vide et qu'on n'est pas en haut du tableau
                    while (currentX > 0 && gameBoard[currentX - 1][y] == 0) {
                        currentX--; // Décrémente pour remonter d'une ligne
                    }

                    // Traitement des cas après le déplacement
                    if (currentX == 0) { // Si on est arrivé en haut du tableau
                        gameBoard[0][y] = value; // Place la valeur en haut
                        // Vide la case d'origine seulement si la tuile a bougé
                        if (currentX != x) {
                            gameBoard[x][y] = 0;
                        }
                    } else if (gameBoard[currentX - 1][y] != value) { // Si la case précédente a une valeur différente
                        gameBoard[currentX][y] = value;   // Place la valeur à la position actuelle (juste en dessous de la case différente)
                        // Vide la case d'origine seulement si la tuile a bougé
                        if (currentX != x) {
                            gameBoard[x][y] = 0;
                        }
                    } else { // Si la case précédente a la même valeur (Cas de fusion)
                        gameBoard[currentX - 1][y] *= 2; // Double la valeur de la case précédente (fusion)
                        score += gameBoard[currentX - 1][y]; // Ajoute le résultat de la fusion au score
                        gameBoard[x][y] = 0;   // Vide la case d'origine (toujours nécessaire en cas de fusion)
                    }
                }
            }
        }
    }
}